diff -rNci gcc-2.7.2/loop.c gcc-2.7.2p/loop.c
*** gcc-2.7.2/loop.c	Tue Oct  3 16:17:16 1995
--- gcc-2.7.2p/loop.c	Tue Jan 23 09:25:29 1996
***************
*** 39,44 ****
--- 39,45 ----
  #include "rtl.h"
  #include "obstack.h"
  #include "expr.h"
+ #include "basic-block.h" /* intel1 */
  #include "insn-config.h"
  #include "insn-flags.h"
  #include "regs.h"
***************
*** 46,51 ****
--- 47,53 ----
  #include "recog.h"
  #include "flags.h"
  #include "real.h"
+ #include "reload.h" /* intel1 */
  #include "loop.h"
  
  /* Vector mapping INSN_UIDs to luids.
***************
*** 97,107 ****
  
  rtx *loop_number_exit_labels;
  
- /* Indexed by loop number, counts the number of LABEL_REFs on
-    loop_number_exit_labels for this loop and all loops nested inside it.  */
- 
- int *loop_number_exit_count;
- 
  /* Holds the number of loop iterations.  It is zero if the number could not be
     calculated.  Must be unsigned since the number of iterations can
     be as high as 2^wordsize-1.  For loops with a wider iterator, this number
--- 99,104 ----
***************
*** 191,196 ****
--- 188,196 ----
  
  static struct obstack temp_obstack;
  
+ /* intel1 */
+ extern struct obstack momentary_obstack;
+ 
  /* This is where the pointer to the obstack being used for RTL is stored.  */
  
  extern struct obstack *rtl_obstack;
***************
*** 286,291 ****
--- 286,349 ----
  static int last_use_this_basic_block ();
  static void record_initial ();
  static void update_reg_last_use ();
+ /* intel1 */
+ static int compare_elimination ();
+ static attempt_new_rtx ();
+ static rtx make_new_use ();
+ static int possible_compare_elimination ();
+ static void find_regs_mentioned ();
+ static void use_regs_source ();
+ static rtx replace_mems ();
+ static void replace_reg  ();
+ static int two_to_power ();
+ static int jumps_back_in_loop ();
+ static loop_copy_propogate ();
+ static do_replace ();
+ static rtx subst_cands ();
+ static try_unroll_propogation ();
+ static rtx unroll_subst_cands ();
+ static unroll_consistancy_maintained ();
+ static int do_reduce_index ();
+ static loop_spl ();
+ void loop_after_global ();
+ static int spill_invariant_p ();
+ static void move_spills_out ();
+ static void move_spill_movables ();
+ static rtx subst_stack_slot ();
+ static int check_if_jumps_out_of_loop ();
+ static void mark_regs_alive_at_exit ();
+ static void verify_spill_candidates ();
+ static void mark_spill_candidates ();
+ static void spill_handle_regs_mentioned ();
+ static int is_updated_by_const ();
+ static int is_updated_by_const_or_reg ();
+ static void peep_init_info ();
+ static void spill_peep_insn ();
+ void update_stack_offset ();
+ static void replace_spill_slots ();
+ static rtx replace_linked_regs ();
+ static void mark_regs_live_outside ();
+ static void mark_regs_mentioned ();
+ static int loop_contains_loop ();
+ static void push_load_into_loop ();
+ static int spill_slot_unused_between ();
+ static int spill_slot_mentioned ();
+ void init_undo_buf ();
+ void subst_in_insn ();
+ static void inner_subst_in_insn ();
+ void loop_undo_all ();
+ static void update_last_reloads ();
+ static void sign_extension_reduction ();
+ static void validate_all_references ();
+ static void lift_stores ();
+ static void mark_mem_refs ();
+ static void insert_mem_ref ();
+ static void opt_reg_use_copy ();
+ int doing_spl = 0;
+ int doing_loop_after_global = 0;
+ static char * reg_live_outside_loop;
+ static int cur_stack_offset = 0;
+ 
  
  /* Relative gain of eliminating various kinds of operations.  */
  int add_cost;
***************
*** 293,298 ****
--- 351,360 ----
  int shift_cost;
  int mult_cost;
  #endif
+ /* intel1 maximum # of insns in loop for which compare elimination */
+ #ifndef MAX_CMP_ELIM
+ #define MAX_CMP_ELIM 100
+ #endif
  
  /* Benefit penalty, if a giv is not replaceable, i.e. must emit an insn to
     copy the value of the strength reduced giv to its original register.  */
***************
*** 341,346 ****
--- 403,414 ----
  
    max_reg_before_loop = max_reg_num ();
  
+   /* intel1 */
+ #ifdef SAVE_ON_REGS
+   if (!flag_all_mem_givs && flag_opt_reg_use)
+     reg_live_outside_loop = (char *) alloca(max_reg_before_loop);
+ #endif
+ 
    moved_once = (char *) alloca (max_reg_before_loop);
    bzero (moved_once, max_reg_before_loop);
  
***************
*** 358,364 ****
  
    /* Don't waste time if no loops.  */
    if (max_loop_num == 0)
!     return;
  
    /* Get size to use for tables indexed by uids.
       Leave some space for labels allocated by find_and_verify_loops.  */
--- 426,442 ----
  
    /* Don't waste time if no loops.  */
    if (max_loop_num == 0)
!     {
!       /* intel1 */
! #ifdef SAVE_ON_REGS
!       if (!doing_loop_after_global && flag_opt_reg_use)
!         {
!           use_regs_source (f, NULL, 0);
!           opt_reg_use_copy (f);
!         }
! #endif
!       return;
!     }
  
    /* Get size to use for tables indexed by uids.
       Leave some space for labels allocated by find_and_verify_loops.  */
***************
*** 377,383 ****
    loop_outer_loop = (int *) alloca (max_loop_num * sizeof (int));
    loop_invalid = (char *) alloca (max_loop_num * sizeof (char));
    loop_number_exit_labels = (rtx *) alloca (max_loop_num * sizeof (rtx));
-   loop_number_exit_count = (int *) alloca (max_loop_num * sizeof (int));
  
    /* Find and process each loop.
       First, find them, and record them in order of their beginnings.  */
--- 455,460 ----
***************
*** 386,392 ****
    /* Now find all register lifetimes.  This must be done after
       find_and_verify_loops, because it might reorder the insns in the
       function.  */
!   reg_scan (f, max_reg_num (), 1);
  
    /* See if we went too far.  */
    if (get_max_uid () > max_uid_for_loop)
--- 463,470 ----
    /* Now find all register lifetimes.  This must be done after
       find_and_verify_loops, because it might reorder the insns in the
       function.  */
!   /* intel1  Last paramater of reg_scan used to be 1.  */
!   reg_scan (f, max_reg_num (), !doing_loop_after_global);
  
    /* See if we went too far.  */
    if (get_max_uid () > max_uid_for_loop)
***************
*** 437,442 ****
--- 515,557 ----
        scan_loop (loop_number_loop_starts[i], loop_number_loop_ends[i],
  		 max_reg_num ());
  
+   /* intel1 */
+   if (flag_strength_reduce && flag_copy_prop)
+     {  
+       for (i = max_loop_num-1; i >= 0; i--)
+         {
+           if (! loop_invalid[i] && loop_number_loop_ends[i])
+             loop_copy_propogate (loop_number_loop_starts[i], loop_number_loop_ends[i]);
+         }
+     }
+   /* intel1 */
+   if ((flag_lift_stores || flag_runtime_lift_stores) 
+       && !doing_loop_after_global)
+     {  
+       for (i = max_loop_num-1; i >= 0; i--)
+         {
+           if (! loop_invalid[i] && loop_number_loop_ends[i])
+                lift_stores (loop_number_loop_starts[i], loop_number_loop_ends[i]);
+         }
+     }
+ 
+ #ifdef SAVE_ON_REGS
+   if (!doing_loop_after_global && flag_opt_reg_use)
+     {
+       use_regs_source (f, NULL, 0); 
+       opt_reg_use_copy (f);
+     }
+ #endif
+   /* intel1 */
+ #ifdef STORE_NOT_SET_CC0
+ #ifdef STACK_REGS
+   if (flag_sftwr_pipe && !doing_loop_after_global)
+       for (i = max_loop_num-1; i >= 0; i--)
+         {
+           loop_spl (loop_number_loop_starts[i], loop_number_loop_ends[i], i, 0);
+         }
+ #endif
+ #endif
    /* If debugging and unrolling loops, we must replicate the tree nodes
       corresponding to the blocks inside the loop, so that the original one
       to one mapping will remain.  */
***************
*** 493,501 ****
--- 608,636 ----
       if it was used exactly once; contains const0_rtx if it was used more
       than once.  */
    rtx *reg_single_usage = 0;
+   
    /* Nonzero if we are scanning instructions in a sub-loop.  */
    int loop_depth = 0;
  
+   /* intel1 */
+   if (doing_loop_after_global
+      && !(GET_CODE (PREV_INSN (end)) == JUMP_INSN
+      &&   GET_CODE (NEXT_INSN (loop_start)) == CODE_LABEL
+      &&   JUMP_LABEL (PREV_INSN (end)) == NEXT_INSN (loop_start)
+       )
+     )
+   {
+     return;
+   }
+ #ifdef SAVE_ON_REGS
+   if (!flag_all_mem_givs && !doing_loop_after_global
+      && !loop_contains_loop (loop_start, end) && flag_opt_reg_use)
+     {
+       bzero (reg_live_outside_loop, max_reg_before_loop);
+       mark_regs_live_outside (loop_start, end);
+     }
+ #endif
+ 
    n_times_set = (short *) alloca (nregs * sizeof (short));
    n_times_used = (short *) alloca (nregs * sizeof (short));
    may_not_optimize = (char *) alloca (nregs);
***************
*** 591,597 ****
  
    count_loop_regs_set (loop_top ? loop_top : loop_start, end,
  		       may_not_optimize, reg_single_usage, &insn_count, nregs);
! 
    for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
      may_not_optimize[i] = 1, n_times_set[i] = 1;
    bcopy ((char *) n_times_set, (char *) n_times_used, nregs * sizeof (short));
--- 726,733 ----
  
    count_loop_regs_set (loop_top ? loop_top : loop_start, end,
  		       may_not_optimize, reg_single_usage, &insn_count, nregs);
!   /* intel1 added if but not body */
!   if (!doing_loop_after_global)
    for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
      may_not_optimize[i] = 1, n_times_set[i] = 1;
    bcopy ((char *) n_times_set, (char *) n_times_used, nregs * sizeof (short));
***************
*** 644,649 ****
--- 780,787 ----
  	in_libcall = 0;
  
        if (GET_CODE (p) == INSN
+           /* intel1 */
+       && (!doing_loop_after_global || GET_CODE(PATTERN(p)) == SET)
  	  && (set = single_set (p))
  	  && GET_CODE (SET_DEST (set)) == REG
  	  && ! may_not_optimize[REGNO (SET_DEST (set))])
***************
*** 695,705 ****
  	  else if (! ((! maybe_never
  		       && ! loop_reg_used_before_p (set, p, loop_start,
  						    scan_start, end))
! 		      || (! REG_USERVAR_P (SET_DEST (set))
! 			  && ! REG_LOOP_TEST_P (SET_DEST (set)))
  		      || reg_in_basic_block_p (p, SET_DEST (set))))
  	    ;
! 	  else if ((tem = invariant_p (src))
  		   && (dependencies == 0
  		       || (tem2 = invariant_p (dependencies)) != 0)
  		   && (n_times_set[REGNO (SET_DEST (set))] == 1
--- 833,851 ----
  	  else if (! ((! maybe_never
  		       && ! loop_reg_used_before_p (set, p, loop_start,
  						    scan_start, end))
! 		      ||  (!doing_loop_after_global 
! 		           && /* intel1 */!REG_USERVAR_P (SET_DEST (set))
! 		           && ! REG_LOOP_TEST_P (SET_DEST (set)))
  		      || reg_in_basic_block_p (p, SET_DEST (set))))
  	    ;
! 	  else if (((tem = invariant_p (src))
! 	             /* intel1 */ || (doing_loop_after_global 
! 	             && RTX_IS_SPILL_P (p) == 1 && spill_invariant_p (src))
! 	           )
! 	           /* intel1 */
!                     && !(doing_loop_after_global 
! 	            && call_used_regs[REGNO (SET_DEST (set))]
! 	            && loop_has_call)
  		   && (dependencies == 0
  		       || (tem2 = invariant_p (dependencies)) != 0)
  		   && (n_times_set[REGNO (SET_DEST (set))] == 1
***************
*** 749,754 ****
--- 895,901 ----
  		     might span a call.  */
  		  && ! modified_between_p (SET_SRC (set), p,
  					   reg_single_usage[regno])
+           && !doing_loop_after_global /* intel1 */
  		  && no_labels_between_p (p, reg_single_usage[regno])
  		  && validate_replace_rtx (SET_DEST (set), SET_SRC (set),
  					   reg_single_usage[regno]))
***************
*** 966,977 ****
--- 1113,1137 ----
    move_movables (movables, threshold,
  		 insn_count, loop_start, end, nregs);
  
+   /* intel1 */
+   if (doing_loop_after_global && !loop_has_call)
+     {
+       move_spills_out(loop_start, end, nregs);
+     }
    /* Now candidates that still are negative are those not moved.
       Change n_times_set to indicate that those are not actually invariant.  */
    for (i = 0; i < nregs; i++)
      if (n_times_set[i] < 0)
        n_times_set[i] = n_times_used[i];
  
+   /*intel1 */
+ #ifdef SAVE_ON_REGS
+    if (!doing_loop_after_global && flag_opt_reg_use)
+    {
+      use_regs_source(loop_start, end, 1); 
+    }
+ #endif
+ 
    if (flag_strength_reduce)
      strength_reduce (scan_start, end, loop_top,
  		     insn_count, loop_start, end);
***************
*** 1257,1263 ****
  	      /* A reg used for zero-extending mustn't be eliminated.  */
  	      && !m1->partial
  	      && (matched_regs[m1->regno]
! 		  ||
  		  (
  		   /* Can combine regs with different modes loaded from the
  		      same constant only if the modes are the same or
--- 1417,1423 ----
  	      /* A reg used for zero-extending mustn't be eliminated.  */
  	      && !m1->partial
  	      && (matched_regs[m1->regno]
! 		  || 
  		  (
  		   /* Can combine regs with different modes loaded from the
  		      same constant only if the modes are the same or
***************
*** 1534,1539 ****
--- 1694,1706 ----
       rtx end;
       int nregs;
  {
+ /* intel1 */
+ #ifdef SAVE_ON_REGS
+   rtx sinsn,last_sym;
+   int num_sym_adds;
+ #endif
+   /* intel1 */
+   int *insns_deleted;
    rtx new_start = 0;
    register struct movable *m;
    register rtx p;
***************
*** 1548,1553 ****
--- 1715,1760 ----
  
    num_movables = 0;
  
+   /* intel1 */
+   num_movables = 0;
+ 
+ /* intel1 Any insn moved out of loop must be deleted from the log_links
+           of all other insns in the loop.
+ */
+   if (doing_loop_after_global)
+     {
+         insns_deleted = (int *) alloca ((max_uid_for_loop+1) * sizeof (int));
+         bzero(insns_deleted,(max_uid_for_loop+1) * sizeof (int));
+     }
+ /* intel1 */
+ #ifdef SAVE_ON_REGS
+   num_sym_adds=0;
+   last_sym = NULL;
+   for (sinsn=loop_start;flag_opt_reg_use && (sinsn!=end && num_sym_adds < 2);
+         sinsn=NEXT_INSN (sinsn))
+      {
+         if (GET_CODE (sinsn) == INSN
+            && GET_CODE (PATTERN (sinsn)) == SET
+            && GET_CODE (SET_DEST (PATTERN (sinsn))) == REG
+            && GET_CODE (SET_SRC (PATTERN (sinsn))) == PLUS
+            && GET_CODE (XEXP (SET_SRC (PATTERN (sinsn)), 0)) == REG
+            && GET_CODE (XEXP (SET_SRC (PATTERN (sinsn)), 1)) == SYMBOL_REF)
+       {
+         if (last_sym)
+       {
+         if (!rtx_equal_p (XEXP (SET_SRC (PATTERN (sinsn)), 1),
+                         last_sym))
+           {
+             num_sym_adds++;
+           }
+       }
+         else
+       {
+         last_sym = XEXP (SET_SRC (PATTERN (sinsn)), 1);
+       }
+       }
+     }
+ #endif /* SAVE_ON_REGS */
    for (m = movables; m; m = m->next)
      {
        /* Describe this movable insn.  */
***************
*** 1626,1632 ****
  
  	  /* It is also desirable to move if it can be moved at no
  	     extra cost because something else was already moved.  */
! 
  	  if (already_moved[regno]
  	      || (threshold * savings * m->lifetime) >= insn_count
  	      || (m->forces && m->forces->done
--- 1833,1862 ----
  
  	  /* It is also desirable to move if it can be moved at no
  	     extra cost because something else was already moved.  */
! #ifdef SAVE_ON_REGS
!   	  /* intel1 if the insn is regx <- regy + symbol_ref then don't move
!   	     if there is more than one.  
!   	  */
!   	  if (flag_opt_reg_use
!   	     && num_sym_adds > 1 
!   	     && GET_CODE (PATTERN (m->insn)) == SET 
!   	     && GET_CODE (SET_DEST (PATTERN (m->insn))) == REG 
!   	     && GET_CODE (SET_SRC (PATTERN (m->insn))) == PLUS 
!   	     && GET_CODE (XEXP (SET_SRC (PATTERN (m->insn)), 0)) == REG 
!   	     && GET_CODE (XEXP (SET_SRC (PATTERN (m->insn)), 1)) == SYMBOL_REF)
! 	    {
! 	      savings = 0;
! 	    } 
! #endif  	     
! /* intel1 */
! #ifdef STACK_REGS
! #ifdef IS_STACK_MODE
!           if (IS_STACK_MODE (DFmode)
!              && GET_CODE (PATTERN (m->insn)) == SET 
!              && GET_CODE (SET_SRC (PATTERN (m->insn))) == CONST_DOUBLE)
!             savings = 0; /* not worthwhile */
! #endif
! #endif
  	  if (already_moved[regno]
  	      || (threshold * savings * m->lifetime) >= insn_count
  	      || (m->forces && m->forces->done
***************
*** 1659,1669 ****
--- 1889,1912 ----
  		  regs_may_share = gen_rtx (EXPR_LIST, VOIDmode, r1,
  					    gen_rtx (EXPR_LIST, VOIDmode, r2,
  						     regs_may_share));
+                   /* intel1 */
+                   if (doing_loop_after_global 
+                      && INSN_UID (m->insn) <= max_uid_for_loop)
+                     {
+                       insns_deleted[INSN_UID (m->insn)] = 1;
+                     }
  		  delete_insn (m->insn);
  
  		  if (new_start == 0)
  		    new_start = i1;
  
+                   /* intel1 */
+                   if (doing_loop_after_global)
+                     {
+                       RTX_IS_SPILL_P (i1) = RTX_IS_SPILL_P (m->insn);
+                       SPILL_PSEUDO (i1) = SPILL_PSEUDO (m->insn);
+                     }
+                     
  		  if (loop_dump_stream)
  		    fprintf (loop_dump_stream, " moved to %d", INSN_UID (i1));
  		}
***************
*** 1690,1697 ****
  			{
  			  temp = XEXP (temp, 0);
  			  while (temp != p)
! 			    temp = delete_insn (temp);
  			}
  
  		      p = delete_insn (p);
  		      while (p && GET_CODE (p) == NOTE)
--- 1933,1954 ----
  			{
  			  temp = XEXP (temp, 0);
  			  while (temp != p)
!               {
!                   /* intel1 */
!                   if (doing_loop_after_global
!                       && INSN_UID( temp) <= max_uid_for_loop)
!                   {
!                        insns_deleted[INSN_UID( temp)] = 1;
!                   }
!                 temp = delete_insn (temp);
!               }
  			}
+                /* intel1 */
+              if (doing_loop_after_global
+                 && INSN_UID( p) <= max_uid_for_loop)
+              {
+                  insns_deleted[INSN_UID( p)] = 1;
+               }
  
  		      p = delete_insn (p);
  		      while (p && GET_CODE (p) == NOTE)
***************
*** 1712,1717 ****
--- 1969,1981 ----
  				 m->is_equiv ? REG_EQUIV : REG_EQUAL,
  				 m->set_src, REG_NOTES (i1));
  
+                   /* intel1 */
+                   if (doing_loop_after_global)
+                     {
+                       RTX_IS_SPILL_P (i1) = RTX_IS_SPILL_P (m->insn);
+                       SPILL_PSEUDO (i1) = SPILL_PSEUDO (m->insn);
+                     }
+ 
  		  if (loop_dump_stream)
  		    fprintf (loop_dump_stream, " moved to %d", INSN_UID (i1));
  
***************
*** 1813,1818 ****
--- 2077,2088 ----
  			      if (temp == fn_address_insn)
  				fn_address_insn = i1;
  			      REG_NOTES (i1) = REG_NOTES (temp);
+                               /* intel1 */
+                               if (doing_loop_after_global 
+                                  && INSN_UID (temp) <= max_uid_for_loop)
+                                 {
+                                   insns_deleted[INSN_UID (temp)] = 1;
+                                 }
  			      delete_insn (temp);
  			    }
  			}
***************
*** 1868,1873 ****
--- 2138,2150 ----
  		      if (new_start == 0)
  			new_start = i1;
  
+                       /* intel1 */
+                       if (doing_loop_after_global)
+                         {
+                           RTX_IS_SPILL_P (i1) = RTX_IS_SPILL_P (m->insn);
+                           SPILL_PSEUDO (i1) = SPILL_PSEUDO (m->insn);
+                         }
+                         
  		      if (loop_dump_stream)
  			fprintf (loop_dump_stream, " moved to %d",
  				 INSN_UID (i1));
***************
*** 1895,1900 ****
--- 2172,2183 ----
  			  XEXP (temp, 0) = i1;
  			}
  
+                       /* intel1 */
+                       if (doing_loop_after_global 
+                          && INSN_UID (p) <= max_uid_for_loop)
+                         {
+                           insns_deleted[INSN_UID (p)] = 1;
+                         }
  		      delete_insn (p);
  		      do p = NEXT_INSN (p);
  		      while (p && GET_CODE (p) == NOTE);
***************
*** 1959,1966 ****
  			{
  			  for (temp = XEXP (temp, 0); temp != m1->insn;
  			       temp = NEXT_INSN (temp))
! 			    delete_insn (temp);
  			}
  		      delete_insn (m1->insn);
  
  		      /* Any other movable that loads the same register
--- 2242,2263 ----
  			{
  			  for (temp = XEXP (temp, 0); temp != m1->insn;
  			       temp = NEXT_INSN (temp))
! 			    {
!                               /* intel1 */
!                               if (doing_loop_after_global 
!                                  && INSN_UID (temp) <= max_uid_for_loop)
!                                 {
!                                   insns_deleted[INSN_UID (temp)] = 1;
!                                 }
! 			      delete_insn (temp);
! 			    }
  			}
+                       /* intel1 */
+                       if (doing_loop_after_global 
+                          && INSN_UID (m1->insn) <= max_uid_for_loop)
+                         {
+                           insns_deleted[INSN_UID (m1->insn)] = 1;
+                         }
  		      delete_insn (m1->insn);
  
  		      /* Any other movable that loads the same register
***************
*** 1996,2001 ****
--- 2293,2326 ----
  	replace_regs (REG_NOTES (p), reg_map, nregs, 0);
  	INSN_CODE (p) = -1;
        }
+   /* intel1 */
+   /* remove all deleted insns from the log_links of any insn in which
+      they appear */
+   if (doing_loop_after_global)
+     {
+         int i;
+         rtx rn,prev,link;
+ 
+         for (rn=loop_start; rn!=end; rn=NEXT_INSN (rn))
+           {
+               if ((GET_CODE (rn) == INSN || GET_CODE (rn) == JUMP_INSN
+ 	               || GET_CODE (rn) == CALL_INSN) && LOG_LINKS(rn))
+                 {
+                     for (prev = 0, link = LOG_LINKS (rn); link;
+                          prev = link, link = XEXP (link, 1))
+                       {
+                           if (insns_deleted[INSN_UID(XEXP (link, 0))])
+ 	                    {
+ 	                      if (prev)
+ 	                        XEXP (prev, 1) = XEXP (link, 1);
+ 	                      else
+ 	                        LOG_LINKS (rn) = XEXP (link, 1);
+ 	                    }
+                       }
+ 
+                 }
+           }
+     }
  }
  
  #if 0
***************
*** 2246,2252 ****
  	    loop_outer_loop[next_loop] = current_loop;
  	    loop_invalid[next_loop] = 0;
  	    loop_number_exit_labels[next_loop] = 0;
- 	    loop_number_exit_count[next_loop] = 0;
  	    current_loop = next_loop;
  	    break;
  
--- 2571,2576 ----
***************
*** 2278,2283 ****
--- 2602,2610 ----
        uid_loop_num[INSN_UID (insn)] = current_loop;
      }
  
+ 		    /* This loop will be continued with NEXT_INSN (insn).  */
+ 		    insn = PREV_INSN (insn);
+ 
    /* Any loop containing a label used in an initializer must be invalidated,
       because it can be jumped into from anywhere.  */
  
***************
*** 2291,2296 ****
--- 2618,2634 ----
  	loop_invalid[loop_num] = 1;
      }
  
+ 
+ #if HAVE_movstricthi
+   if (flag_sign_extension_elim)
+     {
+       int i;
+       for (i = max_loop_num-1; i >= 0; i--)
+         if (! loop_invalid[i] && loop_number_loop_ends[i])
+           sign_extension_reduction (loop_number_loop_starts[i],
+                                     loop_number_loop_ends [i]);
+     }
+ #endif
    /* Now scan all insn's in the function.  If any JUMP_INSN branches into a
       loop that it is not contained within, that loop is marked invalid.
       If any INSN or CALL_INSN uses a label's address, then the loop containing
***************
*** 2304,2314 ****
       label in our loop and will simplify processing by both us and a
       possible second cse pass.  */
  
    for (insn = f; insn; insn = NEXT_INSN (insn))
      if (GET_RTX_CLASS (GET_CODE (insn)) == 'i')
        {
  	int this_loop_num = uid_loop_num[INSN_UID (insn)];
! 
  	if (GET_CODE (insn) == INSN || GET_CODE (insn) == CALL_INSN)
  	  {
  	    rtx note = find_reg_note (insn, REG_LABEL, NULL_RTX);
--- 2642,2653 ----
       label in our loop and will simplify processing by both us and a
       possible second cse pass.  */
  
+ 
    for (insn = f; insn; insn = NEXT_INSN (insn))
      if (GET_RTX_CLASS (GET_CODE (insn)) == 'i')
        {
  	int this_loop_num = uid_loop_num[INSN_UID (insn)];
!         
  	if (GET_CODE (insn) == INSN || GET_CODE (insn) == CALL_INSN)
  	  {
  	    rtx note = find_reg_note (insn, REG_LABEL, NULL_RTX);
***************
*** 2338,2345 ****
  	  {
  	    rtx p;
  	    rtx our_next = next_real_insn (insn);
- 	    int dest_loop;
- 	    int outer_loop = -1;
  
  	    /* Go backwards until we reach the start of the loop, a label,
  	       or a JUMP_INSN.  */
--- 2677,2682 ----
***************
*** 2351,2377 ****
  		 p = PREV_INSN (p))
  	      ;
  
! 	    /* Check for the case where we have a jump to an inner nested
! 	       loop, and do not perform the optimization in that case.  */
! 
! 	    if (JUMP_LABEL (insn))
! 	      {
! 		dest_loop = uid_loop_num[INSN_UID (JUMP_LABEL (insn))];
! 		if (dest_loop != -1)
! 		  {
! 		    for (outer_loop = dest_loop; outer_loop != -1;
! 			 outer_loop = loop_outer_loop[outer_loop])
! 		      if (outer_loop == this_loop_num)
! 			break;
! 		  }
! 	      }
! 
! 	    /* Make sure that the target of P is within the current loop.  */
! 
! 	    if (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p)
! 		&& uid_loop_num[INSN_UID (JUMP_LABEL (p))] != this_loop_num)
! 	      outer_loop = this_loop_num;
! 
  	    /* If we stopped on a JUMP_INSN to the next insn after INSN,
  	       we have a block of code to try to move.
  
--- 2688,2719 ----
  		 p = PREV_INSN (p))
  	      ;
  
! 	      /* intel1 */
!             if (flag_opt_jumps_out)
!               {
!                 /* Retarget a jump around a sequence that contains jumps out 
!                    of loop to jump out of the loop rather than jump around.  */
!                 while (!(GET_CODE (p) == JUMP_INSN
! 		        && JUMP_LABEL (p) != 0
! 		        && condjump_p (p)
! 		        && ! simplejump_p (p)
! 		        && next_real_insn (JUMP_LABEL (p)) == our_next
! 		       ) &&
! 		      !(GET_CODE (p) == JUMP_INSN 
! 		        && (JUMP_LABEL (p) == 0 
! 		         || (uid_loop_num[INSN_UID (JUMP_LABEL (p))]
! 			    == this_loop_num))
! 		       ) 
! 		      && GET_CODE (p) != CODE_LABEL 
! 		      && !(GET_CODE (p) == NOTE
! 		           && NOTE_LINE_NUMBER (p) == NOTE_INSN_LOOP_BEG) 
! 		      && !(GET_CODE (p) == NOTE
! 		           && NOTE_LINE_NUMBER (p) == NOTE_INSN_LOOP_END)
! 		     )
!                   {
!                     p = PREV_INSN (p);
!                   }
!               }
  	    /* If we stopped on a JUMP_INSN to the next insn after INSN,
  	       we have a block of code to try to move.
  
***************
*** 2381,2388 ****
  	       of the block, invert the jump in P and point it to that label,
  	       and move the block of code to the spot we found.  */
  
! 	    if (outer_loop == -1
! 		&& GET_CODE (p) == JUMP_INSN
  		&& JUMP_LABEL (p) != 0
  		/* Just ignore jumps to labels that were never emitted.
  		   These always indicate compilation errors.  */
--- 2723,2729 ----
  	       of the block, invert the jump in P and point it to that label,
  	       and move the block of code to the spot we found.  */
  
! 	    if (GET_CODE (p) == JUMP_INSN
  		&& JUMP_LABEL (p) != 0
  		/* Just ignore jumps to labels that were never emitted.
  		   These always indicate compilation errors.  */
***************
*** 2407,2413 ****
  			&& uid_loop_num[INSN_UID (loc)] == target_loop_num)
  		      break;
  
! 		if (loc)
  		  {
  		    rtx cond_label = JUMP_LABEL (p);
  		    rtx new_label = get_label_after (p);
--- 2748,2762 ----
  			&& uid_loop_num[INSN_UID (loc)] == target_loop_num)
  		      break;
  
! 		if (loc 
! 		     ||
! 		    /* intel1 Enable the optimization even if no barier
! 		              is found.  This requires adding a jump
! 		              around the section of code moved out - but
! 		              this can win if jumps NOT taken are preferred.  
! 		    */
! 		    (flag_opt_jumps_out 
! 		         && LABEL_NUSES (JUMP_LABEL (p)) == 1))
  		  {
  		    rtx cond_label = JUMP_LABEL (p);
  		    rtx new_label = get_label_after (p);
***************
*** 2424,2430 ****
  		       /* Include the BARRIER after INSN and copy the
  			  block after LOC.  */
  		       new_label = squeeze_notes (new_label, NEXT_INSN (insn));
! 		       reorder_insns (new_label, NEXT_INSN (insn), loc);
  
  		       /* All those insns are now in TARGET_LOOP_NUM.  */
  		       for (q = new_label; q != NEXT_INSN (NEXT_INSN (insn));
--- 2773,2784 ----
  		       /* Include the BARRIER after INSN and copy the
  			  block after LOC.  */
  		       new_label = squeeze_notes (new_label, NEXT_INSN (insn));
! 		       /* intel1 */
! 		       if (loc)
! 		         reorder_insns (new_label, NEXT_INSN (insn), loc);
! 		       else
! 		         reorder_insns (new_label, NEXT_INSN (insn), 
! 		                      PREV_INSN (target));
  
  		       /* All those insns are now in TARGET_LOOP_NUM.  */
  		       for (q = new_label; q != NEXT_INSN (NEXT_INSN (insn));
***************
*** 2438,2445 ****
  			  LABEL_OUTSIDE_LOOP_P bit.  */
  		       if (JUMP_LABEL (insn))
  			 {
- 			   int loop_num;
- 
  			   for (q = 0,
  				r = loop_number_exit_labels[this_loop_num];
  				r; q = r, r = LABEL_NEXTREF (r))
--- 2792,2797 ----
***************
*** 2454,2464 ****
  				 break;
  			       }
  
- 			   for (loop_num = this_loop_num;
- 				loop_num != -1 && loop_num != target_loop_num;
- 				loop_num = loop_outer_loop[loop_num])
- 			     loop_number_exit_count[loop_num]--;
- 
  			   /* If we didn't find it, then something is wrong. */
  			   if (! r)
  			     abort ();
--- 2806,2811 ----
***************
*** 2468,2481 ****
  			  in loop_number_exit_labels, and marked as such.
  			  The easiest way to do this is to just call
  			  mark_loop_jump again for P.  */
  		       mark_loop_jump (PATTERN (p), this_loop_num);
! 
! 		       /* If INSN now jumps to the insn after it,
! 			  delete INSN.  */
! 		       if (JUMP_LABEL (insn) != 0
! 			   && (next_real_insn (JUMP_LABEL (insn))
! 			       == next_real_insn (insn)))
! 			 delete_insn (insn);
  		     }
  
  		    /* Continue the loop after where the conditional
--- 2815,2838 ----
  			  in loop_number_exit_labels, and marked as such.
  			  The easiest way to do this is to just call
  			  mark_loop_jump again for P.  */
+         
  		       mark_loop_jump (PATTERN (p), this_loop_num);
!                        /* intel1 */
!                        if (loc)
!                          {
! 		           /* If INSN now jumps to the insn after it,
! 			      delete INSN.  */
! 		           if (JUMP_LABEL (insn) != 0
! 			       && (next_real_insn (JUMP_LABEL (insn))
! 			           == next_real_insn (insn)))
! 			     delete_insn (insn);
! 			 }
! 		       else
! 		         {
! 		           /* move the jump insn to just before the new_label */
! 		           reorder_insns (insn, NEXT_INSN (insn),
! 		                          PREV_INSN (new_label));
! 		         }
  		     }
  
  		    /* Continue the loop after where the conditional
***************
*** 2484,2494 ****
  		       branch and hence needs no processing.  */
  		    insn = NEXT_INSN (cond_label);
  
! 		    if (--LABEL_NUSES (cond_label) == 0)
! 		      delete_insn (cond_label);
! 
! 		    /* This loop will be continued with NEXT_INSN (insn).  */
! 		    insn = PREV_INSN (insn);
  		  }
  	      }
  	  }
--- 2841,2856 ----
  		       branch and hence needs no processing.  */
  		    insn = NEXT_INSN (cond_label);
  
!                        /* intel1 */
!                     if (loc)
!                       {
! 		        if (--LABEL_NUSES (cond_label) == 0)
! 		          delete_insn (cond_label);
! 		       }
! 		     else
! 		       {
! 		          delete_insn (cond_label);
! 		       }
  		  }
  	      }
  	  }
